#!/usr/bin/env python
# -*- coding: utf-8  -*- 

"""
Script que utiliza pywikipedia para generar páginas automáticamente a partir
de las páginas del manual de Ubuntu
"""

import wikipedia
import re
import urllib

# Lista de comandos a generar
__comandos__ = ['ar', 'arch', 'basename', 'cdp', 'cat', 'chroot',
		'chvt', 'colrm', 'column', 'cp', 'cpio', 'dd',
		'deallocvt', 'df', 'diff', 'dir', 'du', 'egrep',
		'env', 'expr', 'fgrep', 'file', 'flex', 'free',
		'gawk', 'getopt', 'grep', 'groups', 'gunzip',
		'gzip', 'hostname', 'id', 'igawk', 'last', 'ldd',
		'ln', 'login', 'logname', 'look', 'make', 'manpath',
		'mc', 'mev', 'mkdir', 'mkfifo', 'mknod', 'more',
		'mv', 'namei', 'newgrp', 'nice', 'nm', 'objdump',
		'od', 'passwd', 'paste', 'pr', 'printenv', 'ps',
		'pwd', 'reset', 'rev', 'rm', 'rmdir', 'script',
		'setterm', 'skill', 'sleep', 'sln', 'strip', 'stty',
		'su', 'tar', 'telnet', 'test', 'time', 'tload',
		'top', 'touch', 'uname', 'users', 'w', 'wall',
		'whatis', 'watch', 'whereis', 'who', 'whoami', 
		'write', 'xargs', 'yes', 'ytree', 'zcat', 'zcmp',
		'zdiff', 'zforce', 'zgrep', 'zmore', 'znew',
		'banner', 'history', 'exit', 'poweroff', 'mailx',
		'news', 'uname', 'df', 'pack', 'unpack', 'pcat',
		'cmp', 'comm', 'dircmp', 'tree', 'sum', 'uniq',
		'cut', 'tr', 'nl', 'wc', 'split', 'paste', 'join',
		'tail', 'head', 'od']

__fallo__ = 0
__creado__ = 0
__exito__ = 0
__errores__ = []

for com in __comandos__:
    print '\n\n%s\nComando %s\n' % ('-'*50, com)
    # Buscando la página web del manual de "com"
    f = urllib.urlopen("http://manpages.ubuntu.com/\
    manpages/lucid/es/man1/%s.1.html" % com)

    s = f.read()
    try:
        s = unicode(s, "utf-8")
    except:
        pass
    f.close()
    
    entradas = s.splitlines()
    
    re_desc = re.compile("<h4><b>NOMBRE</b></h4><pre>")
    re_sint = re.compile("<h4><b>SINOPSIS</b></h4><pre>")
    
    # Búsqueda de NOMBRE y SINOPSIS
    i = 0
    for e in entradas:
        if re_desc.search(e):
            print "Encontrado en %s" % str(i)
            descrip = entradas[i+1]
            print descrip
        if re_sint.search(e):
            print "Encontrado en %s" % str(i)
            sintax = entradas[i+1]
            print sintax
    i += 1

    # Limpiar descripción
    descrip = descrip.split('-')[1]
    # Introducción completa
    intro = u"La orden '''%s''' %s." % (com, descrip)
    
    # Limpiar sintaxis
    sintax = re.sub(ur"(       |</?[bu]>)", ur"", sintax)
    # Sintaxis completa
    sintaxis = ur"La sintaxis es: {{Comando|%s}}" % sintax
    
    page = wikipedia.Page(wikipedia.Site("wikiunix", "osluca"), com)
    if page.exists():
        print "La página ya existe"
        __creado__ = __creado__ + 1
    else:	
        texto = u"{{TítuloMinúsculas}}{{man|%s}}\n%s\n\n%s\
\n<noinclude>[[Categoría:Órdenes]]</noinclude>" % (com, intro, sintaxis)
        print texto

        wikipedia.output(com)
        page.put(texto, u"BOT - Creando página automática para %s" % com)
        __exito__ += 1

    # Comprobando creación de página
    if not page.exists():
        print "ERROR"
        __fallo__ += 1
        __errores__.append(com)
		

print "\n\n\nESTADISTICAS: "
print " * total = %s" % str(len(__comandos__))
print " * __errores__ = %s" % str(__fallo__)
print " * ya creados = %s" % str(__creado__)
print " * __exito__ = %s" % str(__exito__)
print "\n\n\nREGISTRO DE ERRORES: "
for e in __errores__:
    print "%s " % e
